import * as React from 'react';
export declare type ImageLoaded = {
    file: Object;
    dataUrl: string;
};
export declare type ImageUploaded = {
    url: string;
};
export declare type ImageUploadType = (file: File, reportProgress: (progress: number) => void) => Promise<ImageUploaded>;
export declare type ImageUploadProps = {
    imageLoaded?: (image: ImageLoaded) => void;
    imageUpload: ImageUploadType;
    imageUploadError?: (errorCode: number) => void;
    imageUploaded: (resp: ImageUploaded) => void;
    buttonContent?: JSX.Element | string;
    icon?: JSX.Element;
    style?: React.CSSProperties;
    maxFileSize?: number;
    allowedExtensions?: string[];
};
export declare type ImageUploadState = {
    isUploading: boolean;
    hasError: boolean;
    errorText: string;
    progress: number;
};
declare class ImageUpload extends React.Component<ImageUploadProps, ImageUploadState> {
    static defaultProps: {
        buttonContent: string;
        icon: JSX.Element;
        allowedExtensions: string[];
        maxFileSize: number;
    };
    fileInput: HTMLInputElement;
    state: ImageUploadState;
    props: ImageUploadProps;
    hasExtension: (fileName: string) => boolean;
    handleError: (errorCode: number) => void;
    handleFileSelected: React.ChangeEventHandler<HTMLInputElement>;
    readFile(file: File): Promise<ImageLoaded>;
    handleFileUploadClick: React.MouseEventHandler<HTMLElement>;
    handleReportProgress: (progress: number) => void;
    renderChildren: () => JSX.Element;
    render(): JSX.Element;
}
export default ImageUpload;
//# sourceMappingURL=index.d.ts.map